

 
{{Retargetable Concurrent Small C compiler}}


CON

  STACKSIZE = 100

  {{ comparison attributes }}
  EQ   =    1   {{ 0x01 equal }}
  GE   =  156   {{ 0x9C greater or equal }}
  GEu  =   28   {{ 0x1C greater or equal (unsigned) }}
  GT   =  140   {{ 0x8C greater than }}
  GTu  =   12   {{ 0x0C greater than (unsigned) }}
  LE   =  154   {{ 0x9A less or equal }}
  LEu  =   26   {{ 0x1A less or equal (unsigned) }}
  LT   =  138   {{ 0x8A less than }}
  LTu  =   10   {{ 0x0A less than (unsigned) }}
  NE   =   40   {{ 0x28 not equal }}

  EQf  =    1   {{ 0x01 equal }}
  GEf  =  156   {{ 0x9C greater or equal }}
  GTf  =  140   {{ 0x8C greater than }}
  LEf  =  154   {{ 0x9A less or equal }}
  LTf  =  138   {{ 0x8A less than }}
  NEf  =   40   {{ 0x28 not equal }}

  {{ pcode followed by 0 operands }}
  PCODE_OPER0 = 0
  pNOP     =   0   {{ no operation }}
  pADD12   =   1   {{ add sr to pr }}
  pADD21   =   2   {{ add pr to sr }}
  pAND12   =   3   {{ AND sr to pr }}
  pANEG1   =   4   {{ arith negate pr }}
  pASL12   =   5   {{ arith  left sr by pr into pr }}
  pASR12   =   6   {{ arith  right sr by pr into pr }}
  pCALL1   =   7   {{ call function thru pr }}
  pCLI     =   8   {{ interrupt disable }}
  pCOM1    =   9   {{ ones complement pr }}
  pCSCINIT =  10   {{ concurrent Small C Initialization }}
  pDBL1    =  11   {{ double pr }}
  pDBL2    =  12   {{ double sr }}
  pDIV12   =  13   {{ div pr by sr }}
  pDIV12u  =  14   {{ div pr by sr unsigned }}
  pENTER   =  15   {{ set stack frame on function entry }}
  pLNEG1   =  16   {{ logical negate pr }}
  pMOD12   =  17   {{ modulo pr by sr }}
  pMOD12u  =  18   {{ modulo pr by sr unsigned }}
  pMOVE21  =  19   {{ move pr to sr }}
  pMUL12   =  20   {{ multiply pr by sr }}
  pMUL12u  =  21   {{ multiply pr by sr unsigned }}
  pOR12    =  22   {{ OR sr onto pr }}
  pPOP2    =  23   {{ pop stack into sr }}
  pPUSH1   =  24   {{ push pr onto stack }}
  pPUSH2   =  25   {{ push sr }}
  pPUTbp1  =  26   {{ put pr byte in mem thru sr ptr }}
  pPUTwp1  =  27   {{ put pr word in mem thru sr ptr }}
  pRETURN  =  28   {{ restore stack and return }}
  pSTI     =  29   {{ interrupt enable }}
  pSUB12   =  30   {{ sub sr from pr }}
  pSWAP12  =  31   {{ swap pr and sr }}
  pSWAP1s  =  32   {{ swap pr and top of stack }}
  pSWITCH  =  33   {{ find switch case }}
  pXOR12   =  34   {{ XOR pr with sr }}

  {{ pcode followed by 1 operand }}
  PCODE_OPER1 = 35
  pADDbpn  =  35   {{ add n to mem byte thru sr ptr }}
  pADDSP   =  36   {{ add to stack pointer }}
  pARGCNTn =  37   {{ pass arg count to function }}
  pCMP12   =  38   {{ set pr to (sr CMP pr) }}
  pGETb1p  =  39   {{ get byte into pr from mem thru sr ptr }}
  pGETb1pu =  40   {{ get unsigned byte into pr from mem thru sr ptr }}
  pGETb1s  =  41   {{ get byte into pr from stack }}
  pGETb1su =  42   {{ get unsigned byte into pr from stack }}
  pGETw1p  =  43   {{ get word into pr from mem thru sr ptr }}
  pGETw1s  =  44   {{ get word into pr from stack }}
  pGETw2p  =  45   {{ get word into sr thru sr ptr }}
  pGETw2s  =  46   {{ get word into sr from stack }}
  pPOINT1s =  47   {{ point pr to stack item }}
  pPOINT2s =  48   {{ point sr to stack }}
  pPUSHp   =  49   {{ push word from mem thru sr ptr }}
  pPUSHs   =  50   {{ push word from stack }}

  {{ pcode followed by 2 operands }}
  PCODE_OPER2 = 51
  pADD1n   =  51   {{ add n to pr }}
  pADD2n   =  52   {{ add immediate to sr }}
  pADDwpn  =  53   {{ add n to mem word thru sr ptr }}
  pANDbm1  =  54   {{ bitwise and pr with mem byte thru label }}
  pANDwm1  =  55   {{ bitwise and pr with mem word thru label }}
  pCALLm   =  56   {{ call function directly }}
  pGETb1m  =  57   {{ get byte into pr from mem thru label }}
  pGETb1mu =  58   {{ get unsigned byte into pr from mem thru label }}
  pGETw1m  =  59   {{ get word into pr from mem thru label }}
  pGETw1n  =  60   {{ get word of value n into pr }}
  pGETw2m  =  61   {{ get word into sr from mem (label) }}
  pGETw2n  =  62   {{ get word of value n into sr }}
  pJMPm    =  63   {{ jump to label }}
  pORbm1   =  64   {{ bitwise or pr with mem byte thru label }}
  pORwm1   =  65   {{ bitwise or pr with mem word thru label }}
  pPOINT1m =  66   {{ point pr to mem item thru label }}
  pPOINT2m =  67   {{ point sr to mem thru label }}
  pPUSHm   =  68   {{ push word from mem thru label }}
  pPUTbm1  =  69   {{ put pr byte in mem thru label }}
  pPUTwm1  =  70   {{ put pr word in mem thru label }}
  pXORbm1  =  71   {{ bitwise xor pr with mem byte thru label }}
  pXORwm1  =  72   {{ bitwise xor pr with mem word thru label }}

  {{ pcode followed by 3 operands }}
  PCODE_OPER3 = 73
  pADDbmn  =  73   {{ add n to mem byte thru label }}
  pANDbmn  =  74   {{ bitwise and n with mem byte thru label }}
  pCMP10f  =  75   {{ jump to label if (pr CMP 0) is false }}
  pORbmn   =  76   {{ bitwise or n with mem byte thru label }}
  pPUTbmn  =  77   {{ put n into mem byte thru label }}
  pXORbmn  =  78   {{ bitwise xor n with mem byte thru label }}

  {{ pcode followed by 4 operands }}
  PCODE_OPER4 = 79
  pADDwmn  =  79   {{ add n to mem word thru label }}
  pANDwmn  =  80   {{ bitwise and n with mem word thru label }}
  pORwmn   =  81   {{ bitwise or n with mem word thru label }}
  pPUTwmn  =  82   {{ put n into mem word thru label }}
  pXORwmn  =  83   {{ bitwise xor n with mem word thru label }}


 
DAT
  VM_AX		word	0		{{ primary register (pr)   }}
  VM_BX		word	0		{{ secondary register (sr) }}
  VM_CX		word	0		{{ auxiliary register #1   }}
  VM_DX		word	0		{{ auxiliary register #2   }}
  VM_PC		word	0		{{ program counter         }}
  VM_BP		word	0		{{ stack frame register    }}
  VM_SP		word	0		{{ stack pointer register  }}
  VM_PCODE	byte	0		{{ pseude code operator    }}
  VM_FLAGS	byte	0		{{ flags carry, zero       }}
  VM_STACK	byte	0[STACKSIZE]	{{ stack area              }}



_ra0dir		byte 0[1]




_ra1dir		byte 0[1]




_ra2dir		byte 0[1]




_ra3dir		byte 0[1]




_ra0		byte 0[1]




_ra1		byte 0[1]




_ra2		byte 0[1]




_ra3		byte 0[1]


 

_abs
	byte	pENTER
	byte	pGETw1s,(4)&255
	byte	pCMP10f,(@_2)&255,(@_2)>>8,LTf
	byte	pGETw1s,(4)&255
	byte	pANEG1
	byte	pRETURN
_2
	byte	pGETw1s,(4)&255
	byte	pRETURN

_toascii
	byte	pENTER
	byte	pGETw1s,(4)&255
	byte	pRETURN

 



_timer		word 0[1]




_array		word 0[3]


 

_main
	byte	pENTER
	byte	pCSCINIT
	byte	pADDSP,(-4)&255
	byte	pPUTwmn,(@_ra0dir )&255,(@_ra0dir )>>8,(10)&255,(10)>>8
	byte	pARGCNTn,(0)&255
	byte	pCALLm,(@_sub_has_longname1)&255,(@_sub_has_longname1)>>8
	byte	pPUSHs,(-2)&255
	byte	pARGCNTn,(1)&255
	byte	pCALLm,(@_abs)&255,(@_abs)>>8
	byte	pADDSP,(2)&255
	byte	pPOINT2s,(-2)&255
	byte	pPUTwp1
	byte	pPOINT2s,(-2)&255
	byte	pGETw1p,(0)&255
	byte	pADDwpn,(-1)&255,(-1)>>8
	byte	pPUSHs,(-2)&255
	byte	pARGCNTn,(1)&255
	byte	pCALLm,(@_toascii)&255,(@_toascii)>>8
	byte	pADDSP,(2)&255
	byte	pPOINT2s,(-2)&255
	byte	pPUTwp1
	byte	pPOINT2s,(-2)&255
	byte	pGETw1n,(1)&255,(1)>>8
	byte	pPUTwp1
	byte	pPOINT2s,(-4)&255
	byte	pGETw1n,(1)&255,(1)>>8
	byte	pPUTwp1
	byte	pPOINT2s,(-2)&255
	byte	pGETw1n,(0)&255,(0)>>8
	byte	pPUTwp1
_7
	byte	pGETw2s,(-2)&255
	byte	pGETw1n,(4)&255,(4)>>8
	byte	pCMP12,LT
	byte	pCMP10f,(@_6)&255,(@_6)>>8,NEf
	byte	pJMPm,(@_8)&255,(@_8)>>8
_5
	byte	pPOINT2s,(-2)&255
	byte	pGETw1p,(0)&255
	byte	pADDwpn,(1)&255,(1)>>8
	byte	pJMPm,(@_7)&255,(@_7)>>8
_8
	byte	pGETw1n,(65)&255,(65)>>8
	byte	pPUSH1
	byte	pARGCNTn,(1)&255
	byte	pCALLm,(@_sendbyte1)&255,(@_sendbyte1)>>8
	byte	pADDSP,(2)&255
	byte	pJMPm,(@_5)&255,(@_5)>>8
_6
	byte	pPOINT2s,(-2)&255
	byte	pGETw1n,(0)&255,(0)>>8
	byte	pPUTwp1
_11
	byte	pGETw2s,(-2)&255
	byte	pGETw1n,(4)&255,(4)>>8
	byte	pCMP12,LT
	byte	pCMP10f,(@_10)&255,(@_10)>>8,NEf
	byte	pJMPm,(@_12)&255,(@_12)>>8
_9
	byte	pPOINT2s,(-2)&255
	byte	pGETw1p,(0)&255
	byte	pADDwpn,(1)&255,(1)>>8
	byte	pJMPm,(@_11)&255,(@_11)>>8
_12
	byte	pGETw1n,(67)&255,(67)>>8
	byte	pPUSH1
	byte	pARGCNTn,(1)&255
	byte	pCALLm,(@_sendbyte1)&255,(@_sendbyte1)>>8
	byte	pADDSP,(2)&255
	byte	pJMPm,(@_9)&255,(@_9)>>8
_10
_13
	byte	pJMPm,(@_13)&255,(@_13)>>8
_14
	byte	pRETURN

_sendbyte1
	byte	pENTER
	byte	pRETURN

_sub_has_longname1
	byte	pENTER
	byte	pRETURN

_sub_has_longnam2
	byte	pENTER
	byte	pRETURN
PUB start

  VM_SP := @VM_STACK + STACKSIZE  {{initialize stack }}
  VM_PC := @_main                 {{initialize program counter }}

  {{ VM mainloop }}
  repeat  
    vm_pcode := byte[VM_PC++]              {{ pcode }}
    if vm_pcode => PCODE_OPER1
      vm_DX.byte[0] := byte[VM_PC++]       {{ operand 1 }}
      if vm_pcode => PCODE_OPER2
        vm_DX.byte[1] := byte[VM_PC++]     {{ operand 2 }}
        if vm_pcode => PCODE_OPER3
          vm_CX.byte[0] := byte[VM_PC++]   {{ operand 3 }}
          if vm_pcode => PCODE_OPER4
            vm_CX.byte[1] := byte[VM_PC++] {{ operand 4 }}
            {{pcode operators with 4 operands}}
            case VM_PCODE
              pADDwmn:  {{ add n to memory word thru label }}
              pANDwmn:  {{ bitwise and n with mem word thru label }}
              pORwmn:   {{ bitwise or n with mem word thru label }}
              pPUTwmn:  {{ put n into memory word thru label }}
              pXORwmn:  {{ bitwise xor n with mem word thru label }}
          else
            {{pcode operators with 3 operands}}
            case VM_PCODE
              pADDbmn:  {{ add n to memory byte thru label }}
              pANDbmn:  {{ bitwise and n with memory byte }}
              pCMP10f:  {{ jump to label if (pr CMP 0) is false }}
              pORbmn:   {{ bitwise or n with memory byte }}
              pPUTbmn:  {{ put n into memory byte thru label }}
              pXORbmn:  {{ bitwise xor n with memory byte }}
        else
          {{pcode operators with 2 operands}}
          case VM_PCODE
            pADD1n:   {{ add n to pr }}
            pADD2n:   {{ add n to sr }}
            pADDwpn:  {{ add n to memory word thru sr pointer }}
            pANDbm1:  {{ bitwise and pr with mem byte thru label }}
            pANDwm1:  {{ bitwise and pr with mem word thru label }}
            pCALLm:   {{ call function directly }}
            pGETb1m:  {{ get byte into pr from memory thru label }}
            pGETb1mu: {{ get unsigned byte into pr from memory thru label }}
            pGETw1m:  {{ get word into pr from memory thru label }}
            pGETw1n:  {{ get word of value n into pr }}
            pGETw2m:  {{ get word into sr from memory thru label }}
            pGETw2n:  {{ get word of value n into sr }}
            pJMPm:    {{ jump to label }}
            pORbm1:   {{ bitwise or pr with mem byte thru label }}
            pORwm1:   {{ bitwise or pr with mem word thru label }}
            pPOINT1m: {{ point pr to memory item thru label }}
            pPOINT2m: {{ point sr to memory item thru label }}
            pPUSHm:   {{ push word from memory thru label }}
            pPUTbm1:  {{ put pr byte into memory thru label }}
            pPUTwm1:  {{ put pr word into memory thru label }}
            pXORbm1:  {{ bitwise xor pr with mem byte thru label }}
            pXORwm1:  {{ bitwise xor pr with mem word thru label }}
      else
        {{pcode operators with 1 operand}}
        case VM_PCODE
          pADDbpn:  {{ add n to memory byte through sr pointer }}
          pADDSP:   {{ add n to stackpointer }}
          pARGcntn: {{ pass argument count to function }}
          pCMP12:   {{ set pr to (sr CMP pr) }}
          pGETb1p:  {{ get byte into pr from memory thru sr pointer }}
          pGETb1pu: {{ get unsigned byte into pr from memory thru sr pointer }}
          pGETb1s:  {{ get byte into pr from stack }}
          pGETb1su: {{ get unsigned byte into pr from stack }}
          pGETw1p:  {{ get word into pr from memory thru sr pointer }}
          pGETw1s:  {{ get word into pr from stack }}
          pGETw2p:  {{ get word into sr from memory thru sr pointer }}
          pGETw2s:  {{ get word into sr from stack }}
          pPOINT1s: {{ point pr to stack item }}
          pPOINT2s: {{ point sr to stack item }}
          pPUSHp:   {{ push word from memory thru sr pointer }}
          pPUSHs:   {{ push word from stack }}
    else
      {{pcode operators with 0 operands}}
      case VM_PCODE
        pNOP:     {{ no operation }}
        pADD12:   {{ add sr to pr }}
        pADD21:   {{ add pr to sr }}
        pAND12:   {{ and pr with sr }}
        pANEG1:   {{ arithmetically negate pr }}
        pASL12:   {{ arithmetically  left sr by pr into pr }}
        pASR12:   {{ arithmetically  right sr by pr into pr }}
        pCALL1:   {{ call function thru pr }}
        pCLI:     {{ disable interrupt }}
        pCOM1:    {{ one complement pr }}
        pCSCINIT: {{ initialize csc }}
        pDBL1:    {{ double pr }}
        pDBL2:    {{ double sr }}
        pDIV12:   {{ divide pr by sr }}
        pDIV12u:  {{ divide pr by sr (unsigned) }}
        pENTER:   {{ set stack frame upon function entry }}
        pLNEG1:   {{ logical negation of pr }}
        pMOD12:   {{ modulo pr by sr }}
        pMOD12u:  {{ modulo pr by sr (unsigned) }}
        pMOVE21:  {{ move pr to sr }}
        pMUL12:   {{ multiply pr by sr }}
        pMUL12u:  {{ multiply pr by sr (unsigned) }}
        pOR12:    {{ or pr with sr }}
        pPOP2:    {{ pop stack into sr }}
        pPUSH1:   {{ push pr onto stack }}
        pPUSH2:   {{ push sr onto stack }}
        pPUTBP1:  {{ put pr byte into memory thru sr pointer }}
        pPUTWP1:  {{ put pr word into memory thru sr pointer }}
        pRETURN:  {{ restore stack and return }}
        pSTI:     {{ enable interrupt }}
        pSUB12:   {{ subtract sr from pr }}
        pSWAP12:  {{ swap pr and sr }}
        pSWAP1s:  {{ swap pr and top of stack }}
        pSWITCH:  {{ scan switch table to find case }}
        pXOR12:   {{ xor pr with sr }}



